#!/bin/bash

. config

buf0len=55
buf0output="\\251A\\251B\\011CDTestingFu\\255Z\\002Ba\\255l\\128" # ASCII decoded
buf1len=25
buf1output="AAAAAABBBBBBCDTestingFuZZBall" # RLE decoded

RLEaddr=(0x`objdump -d hexrle |grep 'call.*RunLengthDecode'|awk '{print $1}'|sed -s 's/://g'`)
RLEendaddr="0x"`/bin/echo "obase=16; $((RLEaddr+5))"|bc`

HEXaddr=(0x`objdump -d hexrle |grep 'call.*ASCIIHexDecode'|awk '{print $1}'|sed -s 's/://g'`)
HEXendaddr=0x`echo "obase=16;$((HEXaddr+5))"|bc`

PROG="$FUZZBALL -random-seed $RANDOMSEED -solver $SOLVER -no-fail-on-huer -stp-path $STPPATH -solver-slow-time 10 $X87EMU ./hexrle -linux-syscalls -zero-memory -trace-assigns-string -trace-iterations -trace-syscalls"

CMD1="$PROG -fuzz-start-addr $RLEaddr -fuzz-end-addr $RLEendaddr -symbolic-region 0xc0fe1000+$buf1len -target-string 0xc0fe2000='$buf1output' -target-guidance 0.95 -trace-target -finish-on-target-match -- ./hexrle $buf0len $buf1len '$buf1output'"

CMD2="$PROG -fuzz-start-addr $HEXaddr -fuzz-end-addr $HEXendaddr -symbolic-region 0xc0fe0000+$buf0len -target-string 0xc0fe1000='$buf0output' -target-guidance 0.95 -trace-target -finish-on-target-match -- ./hexrle $buf0len $buf1len '$buf1output'"


echo $CMD1
echo $CMD2
echo "#!/bin/bash" > tmp.sh
echo $CMD1 >> tmp.sh
echo $CMD2 >> tmp.sh
/usr/bin/time -f "Kernel %S User %U" -a bash tmp.sh
rm tmp.sh
