#!/bin/bash

. config

# Where do we start SE?
Saddr=(0x`objdump -d simple |grep 'call.*foo'|awk '{print $1}'|sed -s 's/://g'`)
let STARTaddr="$Saddr+5"

# Where do we stop SE?
ENDaddr=(0x`objdump -d simple |grep 'call.*bar'|awk '{print $1}'|sed -s 's/://g'`)

# Where do we check the vulnerability condition?
CHECKaddr=(0x`objdump -d simple |grep '\$0x2a'|grep 'cmp'|awk '{print $1}'|sed -s 's/://g'`)

# Program parameters
PROG="$FUZZBALL -random-seed $RANDOMSEED -solver $SOLVER -no-fail-on-huer -stp-path $STPPATH -solver-slow-time 10 $X87EMU ./simple -linux-syscalls -zero-memory -trace-assigns-string -trace-iterations -trace-syscalls"

# Command to execute
CMD1="$PROG -fuzz-start-addr $STARTaddr -fuzz-end-addr $ENDaddr -symbolic-region 0xc0fe0000+1 -check-condition-at \"$CHECKaddr:R_EAX:reg32_t == 0x2A:reg32_t\" -finish-on-nonfalse-cond -- ./simple"

echo "#!/bin/bash" > tmp.sh
echo $CMD1 >> tmp.sh
echo $CMD1
/usr/bin/time -f "Kernel %S User %U" -a bash tmp.sh
rm tmp.sh
